require "yaml"

class Config
  include YAML::Serializable

  property helixOAuth : String
  property helixClientID : String
  property gqlOAuth : String
  property gqlClientID : String
  property apiEndpoint : String? = "https://api.twitch.tv/helix"
  property gqlEndpoint : String? = "https://gql.twitch.tv/gql"
  property redis_addr : String? = "127.0.0.1:6379"
  property redis_socket : String?
  property redis_database : Int32?
  property port : Int32 = 8080

  def self.load
    config_file = "config/config.yml"
    config_yaml = File.read(config_file)
    config = Config.from_yaml(config_yaml)
    config
  end
end
