require "http/server"
require "kemal"
require "json"
require "uri"
require "redis"
require "colorize"

require "./config"
require "./routes/**"
require "./datahandlers/**"
require "./twitchapi/*"
require "./utils/*"

module TwAPI
end

CONFIG      = Config.load
Kemal.config.port = CONFIG.port
REDIS_UTILS = TwAPI::Utils::Redis
REDIS_DB = Redis::Client.new(URI.parse("redis://#{CONFIG.redis_addr}/#{CONFIG.redis_database}#?keepalive=true"))
puts "Connected to Redis"

# Fiber 
spawn do
  loop do
    begin
      response = JSON.parse(TwAPI::Utils.validate_token)
	  puts "#{"[INFO]".colorize(:green)} Token information:"
	  puts "Client-Id:\t\t#{response["client_id"]}"
	  puts "Login:\t\t\t#{response["login"]}"
	  puts "Token exipires in:\t#{response["expires_in"]} (#{response["expires_in"] == 0 ? "Token does not expire" : Time.utc.shift(response["expires_in"].to_s.to_i, 0)})"
    rescue ex
      puts "#{"[ERROR]".colorize(:red)} #{ex.message}"
    end
	sleep 3600
  end
end

TwAPI::Routes.register_misc
TwAPI::Routes.register_all_twitch

{% if flag?(:release) || flag?(:production) %}
  Kemal.config.env = "production" if !ENV.has_key?("KEMAL_ENV")
{% end %}

Kemal.run
Fiber.yield