module TwAPI::TwitchAPI::Helix
  extend self

  def getId(login)
    request = "#{CONFIG.apiEndpoint}/users?login=#{login}"
    JSON.parse(req(request))["data"][0]["id"]
  end

  def req(request)
    headers = HTTP::Headers{
      "Content-Type"  => "application/json",
      "Authorization" => "Bearer #{CONFIG.helixOAuth}",
      "Client-Id"     => "#{CONFIG.helixClientID}",
    }
    response = HTTP::Client.get(request, headers: headers)

    if response.success?
      (response.body)
    else
      raise "Helix Twitch API returned #{response.status_code}: #{response.body}"
    end
  end
end
